/***************************************************************************
 *   Copyright (C) 2004 by Work@                                           *
 *   jstubbs@work-at.co.jp                                                 *
 *                                                                         *
 *   This program may be distributed under the terms of the Q Public       *
 *   License as defined by Trolltech AS of Norway and appearing in the     *
 *   file LICENSE.QPL included in the packaging of this file.              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 ***************************************************************************/

#ifndef __TABULATOR_H__
#define __TABULATOR_H__

#include <qobject.h>

#include "datatypes.h"
#include "settings.h"
#include "cache.h"

class Tabulator
	: public QObject
{
	Q_OBJECT
	
	signals:
		void fileReady(QString);
	
	public slots:
		void clean(QString);
		void create();
	
	protected slots:
		void receive(QString url, ItemList items);
		void skip(QString url);
		void cancel();
	
	public:
		Tabulator(Settings*, Cache*, QWidget* parent = 0, const char* name = 0);
	
	private:
		void next();
		void done();
		
		QStringList files;
		Settings* settings;
		Cache* cache;
		SiteList sites;
		int fidx;
		QProgressDialog* progress;
};

#endif
