/***************************************************************************
 *   Copyright (C) 2004 by Work@                                           *
 *   jstubbs@work-at.co.jp                                                 *
 *                                                                         *
 *   This program may be distributed under the terms of the Q Public       *
 *   License as defined by Trolltech AS of Norway and appearing in the     *
 *   file LICENSE.QPL included in the packaging of this file.              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *
 ***************************************************************************/

#ifndef __TICKER_H__
#define __TICKER_H__

#include <qvbox.h>
#include <qwidget.h>
#include <qfont.h>
#include <qcolor.h>
#include <qtimer.h>

#include "datatypes.h"

class TickerDisplay
 : public QWidget
{
	Q_OBJECT
	
	signals:
		void urlRequest(QString);
	
	public slots:
		void setFont(QFont font);
		void setBgColor(QColor bg);
		void setFgColor(QColor fg);
		void setTimeout(int timeout);
		void enableScrolling(bool enabled);
		void enableTooltips(bool enabled);
		void enableUnderlining(bool enabled);
		void reset();
	
	protected slots:
		void scroll();
		void repaint(bool erase = false);
	
	public:
		TickerDisplay(QWidget* parent = 0, const char* name = 0);
		void scrollLeft(Link link);
		void scrollRight(Link link);
	
	protected:
		void paintEvent(QPaintEvent*);
		void mousePressEvent(QMouseEvent* e);
		void mouseMoveEvent(QMouseEvent* e);
		void enterEvent(QEvent*);
		void leaveEvent(QEvent*);
	
	private:
		void calcincrement(int exclude);
		
		QFont font;
		QColor bg;
		QColor fg;
		int timeout;
		bool scrolling;
		bool tooltips;
		bool underlining;
		
		bool left;
		double increment;
		LinkList links;
		QValueList<double> positions;
		QTimer timer;
		Link undermouse;
		bool mousein;
		QPoint mousepos;
};

class Ticker
 : public QVBox
{
	Q_OBJECT
	
	signals:
		void urlRequest(QString);
	
	public slots:
		void setFont(QFont font);
		void setBgColor(QColor bg);
		void setFgColor(QColor fg);
		void setTimeout(int timeout);
		void enableScrolling(bool enabled);
		void enableTooltips(bool enabled);
		void enableUnderlining(bool enabled);
		void reset();
	
	public:
		Ticker(QWidget* parent = 0, const char* name = 0);
		void scrollLeft(Item item);
		void scrollRight(Item item);
	
	private:
		TickerDisplay* channel;
		TickerDisplay* headline;
};

#endif
